Subject: Re: bug#10252: bugs in array-map!, array-for-each, others

From: Daniel Llorens <[email-masked]>
Date: Fri, 23 Dec 2011 01:13:30 +0100

On Dec 22, 2011, at 23:17, Andy Wingo wrote:

> Hi Daniel!
> 
> Very interestingly, this bug was totally backwards: they problem wasn't
> in array-map!, it was in generalized-vector-ref (and -set!).

Hello,

I suspected this was the case. Thanks for the review and the fix!

Just a note, the tests "noncompact arrays 3" and "… 4" are the same, the second should be

     (let ((a #2((0 1) (2 3)))
            (c #(0 0)))
        (begin
          (array-map! c + (array-row a 1) (array-col a 1))
          (array-equal? c #(3 6))))

Not that these tests are complete or anything.

> I did not make the array-for-each change, as besides changing public
> API, it is unclear to me why we would want to allow (array-for-each
> proc) to work, as we don't allow (for-each proc) to work.

Hmm, now I can't remember what made me do it. I guess that means I'm ok with things as they are.

Again, thanks for looking into this.

Regards,
	
	Daniel